<?php
#
# DO NOT EDIT THIS FILE
# ---------------------
# You would lose your changes when you upgrade your site. Use php widgets instead.
#

#
# initialize
#

include dirname(__FILE__) . '/inc/init.php';

# set content width
switch ( $sem_options['active_layout'] ) {
case 'm':
	$content_width = 550;
	break;
case 'mm':
	$content_width = 680;
	break;
case 'mmm':
	$content_width = 880;
	break;
case 'smm':
case 'mms':
	$content_width = 580;
	break;
default:
	$content_width = 480;
	break;
}

# load textdomain
load_theme_textdomain('sem-reloaded', sem_path . '/lang');

# kill page comments
if ( !is_admin() )
	add_filter('option_page_comments', 'false');

# kill resource hungry queries
remove_action('wp_head', 'index_rel_link');
remove_action('wp_head', 'parent_post_rel_link');
remove_action('wp_head', 'start_post_rel_link');
remove_action('wp_head', 'adjacent_posts_rel_link');

# initialize options
add_option('sem_api_key', '');

# load depends
include sem_path . '/inc/panels.php';
include sem_path . '/inc/widgets.php';
include sem_path . '/inc/template.php';

if ( file_exists(sem_path . '/custom.php') )
	include sem_path . '/custom.php';

if ( is_admin() ) {
	if ( !function_exists('load_multipart_entry') ) :
	function load_multipart_entry() {
		include_once dirname(__FILE__) . '/inc/multipart-entry/multipart-entry.php';
	} # load_multipart_entry()
	endif;

	function sem_header_admin() {
		include_once sem_path . '/inc/header.php';
	}
	
	add_action('load-appearance_page_header', 'sem_header_admin');
	foreach ( array('post.php', 'post-new.php', 'page.php', 'page-new.php') as $hook ) {
		add_action("load-$hook", 'sem_header_admin');
		add_action("load-$hook", 'load_multipart_entry');
	}
	
	function sem_layout_admin() {
		include_once sem_path . '/inc/layout.php';
	}
	
	add_action('load-appearance_page_layout', 'sem_layout_admin');
	
	function sem_skin_admin() {
		include_once sem_path . '/inc/skin.php';
	}
	
	add_action('load-appearance_page_skin', 'sem_skin_admin');
	
	function sem_custom_admin() {
		include_once sem_path . '/inc/custom.php';
	}
	
	if ( !( function_exists('is_multisite') && is_multisite() ) ) {
		add_action('load-appearance_page_custom', 'sem_custom_admin');
	}
	
	function sem_update() {
		include_once sem_path . '/inc/update.php';
	}
	
	add_action('load-update.php', 'sem_update');
} elseif ( isset($_GET['preview']) && $_GET['preview'] == 'custom-css' ) {
	include_once dirname(__FILE__) . '/inc/custom.php';
}
?>